<!DOCTYPE html
  PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" 
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<?php
# Mark Ashdown, <www.mark.ashdown.name>, August 2004.
#
# You are free to use this program as long as you leave my name
# and website address in it.
#
# 2006-06-13: enabled the show directories siwtch
#			  fixed sorting by file name

#-----------------------------------------
# Is there a way to generate an error if an undefined
# variable is used, rather than just silently continuing?
#
# To Do
#
# Done
# - Remove this file (e.g. index.php) from the listing.
# - Sorting by name doesn't seem to work

# Options		
$showdirs   = true;  # display directories in the listing?
$sortorder  = 1;     # 1=name, 2=size
$showhidden = false; # show files starting with .

# Set the options
switch($_GET['sort']):
case 'name': $sortorder=1; break;
case 'size': $sortorder=2; break;
endswitch;

# Simply write a line of text and a carriage return.
function writeln($str)
{
	echo $str."\n";
}

# The size of the file as a string, in easy-to-read units.
function fileSizeString($size)
{	
	$frac = -1;
	if($size<1024) { $units='B'; }
	elseif ($size<(1024*1024))
	{ 
		$size=$size/1024; 
		$frac=$size%1024; 
		$units='kB'; 
	}
	elseif ($size<(1024*1024*1204))
	{ 
		$size=$size/(1024*1024); 
		$frac=$size%(1024*1024); 
		$units='MB';
	}	
	else 
	{ 
		$size=$size/(1024*1024*1024);
		$frac=$size%(1024*1024*1024);
		$units='GB'; 
	}

	if($size<10 && $frac>=0) 
		return sprintf('%2d.%1d %s', $size, $frac, $units);
	else return sprintf('%4d %s', $size, $units);
}

function anchor($f)
{
	return "<a href=\"$f\">$f</a>";
}

function listFiles($dir)
{
	global $showdirs, $sortorder, $showhidden;

	writeln('<table class="dir">');
	writeln('<tr><th><pre><a href="?sort=name">file name</a></pre></th>'.
	        '<th><pre>  <a href="?sort=size">size</a></pre></th></tr>');
	#$files  = scandir($dir); # PHP 5 and higher
	# This long winded version works from about PHP 3.
	$handle = opendir($dir);
	$files = array();
	$count = 0;
	while(1)
	{
		$name = readdir($handle);
		if($name==false) break;
		$files[$count++] = $name;
	}
	closedir($handle);
	
	# Make an array that maps file names to file sizes.
	$files2 = array();
	$nfiles = 0;
	$ndirs  = 0;
	# Get file sizes
	foreach ($files as $f) 
	{
		if($showhidden || ($f{0}!='.'))
			$files2[$f] = filesize($f);
	}
	# If the files should be sorted by size, do that.
	if($sortorder==2) asort($files2);
	else ksort($files2,SORT_STRING);  # sort by key

	#foreach (glob('*') as $f) 
	foreach ($files2 as $f=>$size) 
	{
		if($f=='index.php')
		{
			# do nothing - omit this PHP file from the listing.
		}
		else if(is_dir($f))
		{
			$ndirs++;
			if($showdirs)
 			writeln("<tr><td><pre>". anchor($f,$f).
				"</pre></td> <td><pre>" . '   &lt;dir&gt;' . 
				"</pre></td></tr>");
		}
		else
		{
			$nfiles++;
	 		writeln("<tr><td><pre>". anchor($f,$f).
				"</pre></td> <td><pre> " . fileSizeString($size) . 
				"</pre></td></tr>");
		}
	}
	writeln('</table>');
	if($showdirs) 
		writeln("<p>$nfiles file".($nfiles==1?'':'s').
		        ", $ndirs director".($ndirs==1?'y':'ies').".</p>");
	else writeln("<p>$nfiles file".($nfiles==1?'':'s').".</p>");
}
#-----------------------------------------
?>

<html>
<!-- File listing PHP script, v0.2 -->
<!-- By Mark Ashdown <http://www.mark.ashdown.name> -->
<head>
<title>File List</title>
<style type="text/css">
TABLE.dir{
    font-family: monospace;
}
TABLE.dir PRE{
	margin: 0;
	padding: 0;
}
TABLE.dir TH{
	text-align: left;
}
</style>
</head>				

<body>

<h1>File Listing</h1>
<?php listFiles('.'); ?>

</body>
</html>

